/* tslint:disable */
/* eslint-disable */
/* prettier-ignore */
// This document is generated by rokot-apicontroller-client-generator. DO NOT edit directly.

export interface HeaderMap {
    [k: string]: string;
}

export interface IFetcher {
    request<T>(url: string, verb: string, contentType: string, body?: any, headers?: HeaderMap): Promise<T>;
    buildQueryString(query?: any): string;
    requestValidate?(routeUniqueName: string, paramValues: {
        body?: any;
        params?: any;
        query?: any;
    }): Promise<void>;
}

export enum TestEnum {
    One = "TestOne",
    Two = "TestTwo",
    Three = "TestThree"
}

export class ClassOne {
    kind: TestEnum.One;
    property: string;
}

export class ClassTwo {
    kind: TestEnum.Two;
    property: number;
}

export class ClassThree {
    kind: TestEnum.Three;
    property: boolean;
}

export type TestGetAllResponse = ClassOne | ClassTwo | ClassThree;

export class TestController {
    constructor(private fetcher: IFetcher) { }
    getAll = (headers?: HeaderMap): Promise<TestGetAllResponse> => {
        return this.fetcher.request<TestGetAllResponse>(`test/all`, "get", "application/json", undefined, headers);
    };
}

export class ApiClient {
    constructor(private fetcher: IFetcher) { }
    test = new TestController(this.fetcher);
}